diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCrystalCone.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCrystalCone.java
new file mode 100644
index 000000000..c92dfa50d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureCrystalCone.java
@@ -0,0 +1,168 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class WorldFeatureCrystalCone extends WorldFeature
+{
+    private final boolean ceilingGen;
+
+    public WorldFeatureCrystalCone(boolean ceilingGen){
+        this.ceilingGen = ceilingGen;
+    }
+
+    protected void assignValue(int x, int y, int z, int id, int meta, World world) {
+        /* assign a block to the world */
+        world.setBlockAndMetadata(x, y, z, id, meta);
+    }
+
+    protected void crossSection(int[] center, double radius, int dirAxis, int id, int data, World world) {
+        int rad = MathHelper.floor(radius + 0.618);
+        int secidx1 = (dirAxis + 1) % 3;
+        int secidx2 = (dirAxis + 2) % 3;
+        int[] coord = new int[3];
+        for (int off1 = -rad; off1 < rad + 1; off1++) {
+            for (int off2 = -rad; off2 < rad + 1; off2++) {
+                double thisDist = Math.sqrt(Math.pow(Math.abs(off1) + 0.5, 2) + Math.pow(Math.abs(off2) + 0.5, 2));
+                if (thisDist > radius) {
+                    continue;
+                }
+                int pri = center[dirAxis];
+                int sec1 = center[secidx1] + off1;
+                int sec2 = center[secidx2] + off2;
+                coord[dirAxis] = pri;
+                coord[secidx1] = sec1;
+                coord[secidx2] = sec2;
+                assignValue(coord[0], coord[1], coord[2], id, data, world);
+            }
+        }
+    }
+
+    protected void taperedLimb(int[] start, int[] end, double startSize, double endSize, World world) {
+        // delta is the coordinate vector for the difference between
+        // start and end.
+        int[] delta = new int[] { end[0] - start[0], end[1] - start[1], end[2] - start[2] };
+        int maxDist = MathHelper.maxAbs(delta[0], MathHelper.maxAbs(delta[1], delta[2]));
+        if (maxDist == 0) {
+            return;
+        }
+        int primidx = 0;
+        for (int i = 0; i < 3; i++) {
+            if (delta[i] == maxDist) {
+                primidx = i;
+                break;
+            }
+        }
+        // secidx1 and secidx2 are the remaining indices out of [0,1,2].
+        int secidx1 = (primidx - 1) % 3;
+        if (secidx1 < 0) secidx1 += 3;
+        int secidx2 = (1 + primidx) % 3;
+        // primSign is the digit 1 or -1 depending on whether the limb is headed
+        // along the positive or negative primidx axis.
+        int primSign = delta[primidx] / Math.abs(delta[primidx]);
+        // secdelta1 and ...2 are the amount the associated values change
+        // for every step along the prime axis.
+        int secdelta1 = delta[secidx1];
+        float secfac1 = ((float)secdelta1) / delta[primidx];
+        int secdelta2 = delta[secidx2];
+        float secfac2 = ((float)secdelta2) / delta[primidx];
+        // Initialize coord
+        int[] coord = new int[3];
+        // Loop through each cross-section along the primary axis,
+        // from start to end.
+        int endOffset = delta[primidx] + primSign;
+        int endOffsetAbs = Math.abs(endOffset);
+        int iterator = Math.abs(primSign);
+        for (int primOffsetAbs = 0; primOffsetAbs < endOffsetAbs; primOffsetAbs += iterator) {
+            int primOffset = primOffsetAbs * primSign;
+            int primLoc = start[primidx] + primOffset;
+            int secloc1 = (int)(start[secidx1] + primOffset * secfac1);
+            int secloc2 = (int)(start[secidx2] + primOffset * secfac2);
+            coord[primidx] = primLoc;
+            coord[secidx1] = secloc1;
+            coord[secidx2] = secloc2;
+            int primDist = Math.abs(delta[primidx]);
+            double radius = endSize + (startSize - endSize) * Math.abs(delta[primidx] - primOffset) / primDist;
+            crossSection(coord, radius, primidx, Blocks.CRYSTAL.id(), 0, world);
+        }
+    }
+
+    @Override
+    public boolean place(World world, Random random, int x, int y, int z)
+    {
+        int x1 = (x + random.nextInt(2)) - random.nextInt(2);
+        int z1 = (z + random.nextInt(2)) - random.nextInt(2);
+        int yF = y;
+
+        int radius = 5;
+
+        int checksForGround = 0;
+        boolean canGenerate = false;
+        while(true){
+            int blockId;
+            if(ceilingGen)
+                blockId = world.getBlockId(x1, yF+1, z1);
+            else
+                blockId = world.getBlockId(x1, yF-1, z1);
+
+            if(checksForGround > 64 || yF <= 0 || yF >= world.getHeightBlocks()) {
+                break;
+            }
+
+            if(Blocks.solid[blockId]){
+                canGenerate = true;
+                break;
+            }
+
+            if(ceilingGen)
+                yF ++;
+            else
+                yF --;
+
+            checksForGround++;
+        }
+
+        if(canGenerate && world.isAirBlock(x1, yF, z1))
+        {
+            int rand = random.nextInt(4);
+            if(ceilingGen){
+                switch (rand) {
+                    case 0:
+                        taperedLimb(new int[]{x1, yF + 2, z1}, new int[]{x1 + 24, yF - 24, z1}, radius, 1, world);
+                        break;
+                    case 1:
+                        taperedLimb(new int[]{x1, yF + 2, z1}, new int[]{x1 - 24, yF - 24, z1}, radius, 1, world);
+                        break;
+                    case 2:
+                        taperedLimb(new int[]{x1, yF + 2, z1}, new int[]{x1, yF - 24, z1 + 24}, radius, 1, world);
+                        break;
+                    case 3:
+                        taperedLimb(new int[]{x1, yF + 2, z1}, new int[]{x1, yF - 24, z - 24}, radius, 1, world);
+                        break;
+                }
+            } else {
+                switch (rand) {
+                    case 0:
+                        taperedLimb(new int[]{x1, yF - 2, z1}, new int[]{x1 + 24, yF + 24, z1}, radius, 1, world);
+                        break;
+                    case 1:
+                        taperedLimb(new int[]{x1, yF - 2, z1}, new int[]{x1 - 24, yF + 24, z1}, radius, 1, world);
+                        break;
+                    case 2:
+                        taperedLimb(new int[]{x1, yF - 2, z1}, new int[]{x1, yF + 24, z1 + 24}, radius, 1, world);
+                        break;
+                    case 3:
+                        taperedLimb(new int[]{x1, yF - 2, z1}, new int[]{x1, yF + 24, z - 24}, radius, 1, world);
+                        break;
+                }
+            }
+
+        }
+
+        return true;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java
new file mode 100644
index 000000000..bcdf2cbff
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java
@@ -0,0 +1,173 @@
+package net.minecraft.core.world.generate.feature;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+import java.util.Arrays;
+import java.util.Random;
+
+public class WorldFeaturePillar
+    extends WorldFeature {
+    private static final int MAX_RADIUS = 8;
+    private static int diameter(final int radius) {
+        return radius * 2 + 1;
+    }
+    private static final int CIRCLE_SCALE = 4;
+
+    private final int blockId;
+    private final boolean doLava;
+
+    private boolean[] buffer = new boolean[diameter(MAX_RADIUS) * diameter(MAX_RADIUS)];
+
+    public WorldFeaturePillar(int blockId, boolean doLava) {
+        this.blockId = blockId;
+        this.doLava = doLava;
+    }
+
+    @Override
+    public boolean place(World world, Random random, int x, int y, int z) {
+        int y0 = y;
+
+        while (isEmpty(world, x, y0, z)) {
+            y0--;
+        }
+
+        int y1 = y;
+
+        while (isEmpty(world, x, y1, z)) {
+            y1++;
+        }
+
+        y0 -= 5;
+        y1 += 5;
+
+        int length = y1 - y0;
+
+        float r = random.nextFloat();
+        int initRadiusTop = 1 + (int) (r * (MAX_RADIUS - 2));
+        r = random.nextFloat();
+        int initRadiusBottom = initRadiusTop + (int) (r * (MAX_RADIUS - initRadiusTop));
+        int initRadiusMin = (int) (r * Math.min(initRadiusBottom, initRadiusTop) * 0.75f);
+
+        int randomSkip = random.nextInt(8);
+        if (randomSkip == 0) {
+            initRadiusTop = 0;
+            initRadiusMin = 0;
+        } else if (randomSkip == 1) {
+            initRadiusBottom = 0;
+            initRadiusMin = 0;
+        }
+
+        float bufferedRadius = initRadiusBottom;
+        bufferCircle(random, initRadiusBottom);
+        for (int dy = 0; dy <= length; dy++) {
+            float p = (float) dy / length;
+
+            if (randomSkip == 0 && p > 0.5f) {
+                break;
+            }
+            if (randomSkip == 1 && p < 0.5f) {
+                continue;
+            }
+
+            float lerpedRadius = MathHelper.lerp(initRadiusBottom, initRadiusTop, p);
+            float radMod = (MathHelper.cos((2f * p) * MathHelper.PI) / 2 + 0.5f) * 0.75f + 0.25f;
+            float currentRadius = ((int) (lerpedRadius * radMod * CIRCLE_SCALE)) / (float) CIRCLE_SCALE;
+            if (currentRadius < initRadiusMin) {
+                currentRadius = initRadiusMin;
+            }
+            if (currentRadius != bufferedRadius) {
+                bufferCircle(random, currentRadius);
+                bufferedRadius = currentRadius;
+            }
+
+            for (int dx = 0; dx < diameter(MAX_RADIUS); dx++) {
+                for (int dz = 0; dz < diameter(MAX_RADIUS); dz++) {
+                    if (getBufferPoint(dx, dz)) {
+                        world.setBlockWithNotify(x - MAX_RADIUS + dx, y0 + dy, z - MAX_RADIUS + dz, blockId);
+                    }
+                }
+            }
+        }
+
+        if (doLava) {
+            int largerRadius = Math.max(initRadiusTop, initRadiusBottom);
+            int numFeatures = 8 + random.nextInt(20);
+            for (int i = 0; i < numFeatures; i++) {
+                int rx = random.nextInt(diameter(largerRadius));
+                int rz = random.nextInt(diameter(largerRadius));
+                int ry = random.nextInt(length);
+                if (world.getBlockId(x - largerRadius + rx, y0 + ry, z - largerRadius + rz) == Blocks.COBBLE_NETHERRACK.id()) {
+                    world.setBlockWithNotify(x - largerRadius + rx, y0 + ry, z - largerRadius + rz, Blocks.FLUID_LAVA_FLOWING.id());
+                    world.scheduledUpdatesAreImmediate = true;
+                    Blocks.FLUID_LAVA_FLOWING.updateTick(world, x - largerRadius + rx, y0 + ry, z - largerRadius + rz, random);
+                    world.scheduledUpdatesAreImmediate = false;
+                }
+            }
+        }
+
+        return true;
+    }
+
+    private boolean isEmpty(World world, int x, int y, int z) {
+        if (y < 0 || y >= world.getHeightBlocks()) {
+            return false;
+        }
+        return !Blocks.solid[world.getBlockId(x, y, z)];
+    }
+
+    private void bufferCircle(Random rand, final float r) {
+        Arrays.fill(buffer, false);
+
+        if (r <= 0.5) {
+            return;
+        }
+
+        int ir = (int) (r * CIRCLE_SCALE);
+
+        final int x1 = MAX_RADIUS + 1;
+        final int y1 = x1;
+
+        int x = 0, y = ir;
+        int p = 1 - ir;
+
+        plotPoints(x1, y1, x / CIRCLE_SCALE, y / CIRCLE_SCALE);
+
+        while (x < y)
+        {
+            x++;
+            if (p < 0)
+                p += 2 * x + 1;
+            else
+            {
+                y--;
+                p += 2 * (x - y) + 1;
+            }
+
+            plotPoints(x1, y1, x / CIRCLE_SCALE, y / CIRCLE_SCALE);
+        }
+    }
+
+    private void drawLine(int x0, int x1, int y, boolean value) {
+        for (int x = x0; x <= x1; x++) {
+            setBufferPoint(x, y, value);
+        }
+    }
+
+    private void plotPoints(int cx, int cy, int x, int y) {
+        drawLine(cx - x, cx + x, cy - y, true);
+        drawLine(cx - x, cx + x, cy + y, true);
+        drawLine(cx - y, cx + y, cy - x, true);
+        drawLine(cx - y, cx + y, cy + x, true);
+    }
+
+    private void setBufferPoint(int x, int y, boolean value) {
+        buffer[x * diameter(MAX_RADIUS) + y] = value;
+    }
+
+    private boolean getBufferPoint(int x, int y) {
+        return buffer[x * diameter(MAX_RADIUS) + y];
+    }
+
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/BasePerlinNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/BasePerlinNoise.java
index 2f28130a8..6657ee29f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/BasePerlinNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/BasePerlinNoise.java
@@ -6,19 +6,19 @@ import java.util.Random;
 public abstract class BasePerlinNoise<T extends BaseImprovedNoise>
     extends SurfaceNoise
 {
-    private final T[] noiseLevels;
-    private final int levels;
+    private final T[] octaves;
+    private final int numOctaves;
 
-    public BasePerlinNoise(long seed, int levels)
+    public BasePerlinNoise(long seed, int numOctaves)
     {
-        this(seed, levels, 0);
+        this(seed, numOctaves, 0);
     }
 
-    public BasePerlinNoise(long seed, int levels, int preLevels)
+    public BasePerlinNoise(long seed, int numOctaves, int preOctaves)
     {
         Random random = new Random(seed);
 
-        for (int i = 0; i < preLevels; i++)
+        for (int i = 0; i < preOctaves; i++)
         {
             random.nextDouble();
             random.nextDouble();
@@ -29,20 +29,20 @@ public abstract class BasePerlinNoise<T extends BaseImprovedNoise>
                 random.nextInt(256 - j);
             }
         }
-        this.levels = levels;
-        this.noiseLevels = newNoiseLevels(random, levels);
+        this.numOctaves = numOctaves;
+        this.octaves = newOctaves(random, numOctaves);
     }
 
-    protected abstract T[] newNoiseLevels(Random random, int numLevels);
+    protected abstract T[] newOctaves(Random random, int numOctaves);
 
     public double get(double x, double y)
     {
         double out = 0.0D;
         double levelScale = 1.0D;
 
-        for(int i = 0; i < levels; i++)
+        for(int i = 0; i < numOctaves; i++)
         {
-            out += noiseLevels[i].getValue(x * levelScale, y * levelScale) / levelScale;
+            out += octaves[i].getValue(x * levelScale, y * levelScale) / levelScale;
             levelScale /= 2;
         }
 
@@ -62,11 +62,11 @@ public abstract class BasePerlinNoise<T extends BaseImprovedNoise>
             Arrays.fill(noiseArray, 0.0D);
         }
 
-        double levelScale = 1.0D;
-        for(int i = 0; i < levels; i++)
+        double frequency = 1.0D;
+        for(int i = 0; i < numOctaves; i++)
         {
-            noiseLevels[i].add(noiseArray, x, y, z, xSize, ySize, zSize, scaleX * levelScale, scaleY * levelScale, scaleZ * levelScale, levelScale);
-            levelScale /= 2D;
+            octaves[i].add(noiseArray, x, y, z, xSize, ySize, zSize, scaleX * frequency, scaleY * frequency, scaleZ * frequency, frequency);
+            frequency /= 2D;
         }
 
         return noiseArray;
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/PerlinNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/PerlinNoise.java
index ac319d1e4..daeb826c7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/PerlinNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/PerlinNoise.java
@@ -16,11 +16,11 @@ public class PerlinNoise
     }
 
     @Override
-    protected ImprovedNoise[] newNoiseLevels(Random random, int numLevels)
+    protected ImprovedNoise[] newOctaves(Random random, int numOctaves)
     {
-        ImprovedNoise[] levels = new ImprovedNoise[numLevels];
+        ImprovedNoise[] levels = new ImprovedNoise[numOctaves];
 
-        for (int i = 0; i < numLevels; i++)
+        for (int i = 0; i < numOctaves; i++)
         {
             levels[i] = new ImprovedNoise(random);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/PerlinSimplexNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/PerlinSimplexNoise.java
index 9f39edaa8..92ac51555 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/PerlinSimplexNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/PerlinSimplexNoise.java
@@ -5,16 +5,16 @@ import java.util.Random;
 
 public class PerlinSimplexNoise extends SurfaceNoise
 {
-    private final SimplexNoise[] noiseLevels;
-    private final int levels;
+    private final SimplexNoise[] octaves;
+    private final int numOctaves;
 
-    public PerlinSimplexNoise(Random random, int levels)
+    public PerlinSimplexNoise(Random random, int numOctaves)
     {
-        this.levels = levels;
-        noiseLevels = new SimplexNoise[levels];
-        for(int i = 0; i < levels; i++)
+        this.numOctaves = numOctaves;
+        octaves = new SimplexNoise[numOctaves];
+        for(int i = 0; i < numOctaves; i++)
         {
-            noiseLevels[i] = new SimplexNoise(random);
+            octaves[i] = new SimplexNoise(random);
         }
     }
 
@@ -23,27 +23,28 @@ public class PerlinSimplexNoise extends SurfaceNoise
         return getMaximumValue(0.5);
     }
 
-    // Gets the maximum value for a given value of d5. For those values, the range is from -getMaximumValue to getMaximumValue.
-    public double getMaximumValue(double d5)
+    // Gets the maximum value for a given value of amplitudeScale. For those values, the range is from -getMaximumValue to getMaximumValue.
+    public double getMaximumValue(double amplitudeScale)
     {
         double max = 0.0;
 
-        double scaleB = 1.0;
-        for (int l = 0; l < levels; l++)
+        double amplitude = 1.0;
+        for (int l = 0; l < numOctaves; l++)
         {
-            max += 1.0 * (0.55D / scaleB);
-            scaleB *= d5;
+            max += 0.55D / amplitude;
+            amplitude *= amplitudeScale;
         }
 
         return max;
     }
 
-    public double[] getValue(double[] out, double x, double z, int xSize, int zSize, double xScale, double zScale, double d4)
+    public double[] getValue(double[] out, double x, double z, int xSize, int zSize, double xScale, double zScale, double frequencyScale)
     {
-        return getValue(out, x, z, xSize, zSize, xScale, zScale, d4, 0.5D);
+        return getValue(out, x, z, xSize, zSize, xScale, zScale, frequencyScale, 0.5D);
     }
 
-    public double[] getValue(double[] out, double x, double z, int xSize, int zSize, double xScale, double zScale, double d4, double d5)
+    // Uses Fractal Brownian Motion to refine the noise.
+    public double[] getValue(double[] out, double x, double z, int xSize, int zSize, double xScale, double zScale, double frequencyScale, double amplitudeScale)
     {
         xScale /= 1.5D;
         zScale /= 1.5D;
@@ -57,13 +58,13 @@ public class PerlinSimplexNoise extends SurfaceNoise
             Arrays.fill(out, 0.0D);
         }
 
-        double scaleA = 1.0D;
-        double scaleB = 1.0D;
-        for(int l = 0; l < levels; l++)
+        double frequency = 1.0D;
+        double amplitude = 1.0D;
+        for(int l = 0; l < numOctaves; l++)
         {
-            noiseLevels[l].add(out, x, z, xSize, zSize, xScale * scaleA, zScale * scaleA, 0.55D / scaleB);
-            scaleA *= d4;
-            scaleB *= d5;
+            octaves[l].add(out, x, z, xSize, zSize, xScale * frequency, zScale * frequency, 0.55D / amplitude);
+            frequency *= frequencyScale;
+            amplitude *= amplitudeScale;
         }
 
         return out;
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/RetroPerlinNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/RetroPerlinNoise.java
index 5620888dc..7e1bd7b75 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/RetroPerlinNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/RetroPerlinNoise.java
@@ -16,11 +16,11 @@ public class RetroPerlinNoise
 	}
 
 	@Override
-	protected RetroImprovedNoise[] newNoiseLevels(Random random, int numLevels)
+	protected RetroImprovedNoise[] newOctaves(Random random, int numOctaves)
 	{
-		RetroImprovedNoise[] levels = new RetroImprovedNoise[numLevels];
+		RetroImprovedNoise[] levels = new RetroImprovedNoise[numOctaves];
 
-		for (int i = 0; i < numLevels; i++)
+		for (int i = 0; i < numOctaves; i++)
 		{
 			levels[i] = new RetroImprovedNoise(random);
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java
index 6859b84f3..fd9bff937 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java
@@ -49,8 +49,8 @@ public class SimplexNoise
         return (double)vec[0] * x + (double)vec[1] * y;
     }
 
-    // Values generated are guaranteed to be between -1.0 and 1.0, multiplied by valueScale.
-    public void add(double[] out, double xOffset, double zOffset, int xSize, int zSize, double xScale, double zScale, double valueScale)
+    // Values generated are guaranteed to be between -1.0 and 1.0, multiplied by amplitude.
+    public void add(double[] out, double xOffset, double zOffset, int xSize, int zSize, double xScale, double zScale, double amplitude)
     {
         int index = 0;
         for(int dx = 0; dx < xSize; dx++)
@@ -142,7 +142,7 @@ public class SimplexNoise
                 }
 
                 double value = 70 * (n0 + n1 + n2);
-                out[index++] += value * valueScale;
+                out[index++] += value * amplitude;
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java b/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
index 3d9c5dec3..3365e982b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
@@ -4,6 +4,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.biome.provider.BiomeProviderNether;
 import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.nether.ChunkGeneratorNether;
@@ -26,7 +27,7 @@ public class WorldTypeNether
 
     private static float[] getLightRamp() {
         float[] brightnessRamp = new float[32];
-        float f = 0.1F;
+        float f = 0.15F;
         for (int i = 0; i <= 15; i++) {
             float f1 = 1.0F - (float) i / 15F;
             brightnessRamp[i] = ((1.0F - f1) / (f1 * 3F + 1.0F)) * (1.0F - f) + f;
@@ -43,7 +44,8 @@ public class WorldTypeNether
 
     @Override
     public BiomeProvider createBiomeProvider(World world) {
-        return new BiomeProviderSingleBiome(Biomes.NETHER_NETHER, 1.0, 0.0, 1.0);
+//        return new BiomeProviderSingleBiome(Biomes.NETHER_NETHER, 1.0, 0.0, 1.0);
+        return new BiomeProviderNether(world.getRandomSeed());
     }
 
     @Override
diff --git a/game/core/src/main/resources/lang/en_US/biomes.lang b/game/core/src/main/resources/lang/en_US/biomes.lang
index 4c56f2bb5..88866f1df 100644
--- a/game/core/src/main/resources/lang/en_US/biomes.lang
+++ b/game/core/src/main/resources/lang/en_US/biomes.lang
@@ -1,24 +1,29 @@
-biome.rainforest=Rainforest
-biome.swampland=Swamp
-biome.seasonal_forest=Seasonal Forest
-biome.forest=Forest
-biome.forest.dry=Dry Forest
-biome.grasslands=Grasslands
-biome.outback=Outback
-biome.shrubland=Shrubland
-biome.taiga=Taiga
-biome.boreal_forest=Boreal Forest
-biome.desert=Desert
-biome.plains=Plains
-biome.glacier=Glacier
-biome.tundra=Tundra
-biome.meadow=Meadow
-biome.nether=Nether
-biome.paradise=Paradise
-biome.birch_forest=Birch Forest
-biome.retro=Retro
-biome.hell=Hell
-biome.swampland.muddy=Muddy Swamp
-biome.outback.grassy=Grassy Outback
-biome.caatinga=Caatinga
-biome.caatinga.plains=Caatinga Plains
\ No newline at end of file
+biome.overworld.rainforest=Rainforest
+biome.overworld.swampland=Swamp
+biome.overworld.seasonal_forest=Seasonal Forest
+biome.overworld.forest=Forest
+biome.overworld.forest.dry=Dry Forest
+biome.overworld.grasslands=Grasslands
+biome.overworld.outback=Outback
+biome.overworld.shrubland=Shrubland
+biome.overworld.taiga=Taiga
+biome.overworld.boreal_forest=Boreal Forest
+biome.overworld.desert=Desert
+biome.overworld.plains=Plains
+biome.overworld.glacier=Glacier
+biome.overworld.tundra=Tundra
+biome.overworld.meadow=Meadow
+biome.overworld.paradise=Paradise
+biome.overworld.birch_forest=Birch Forest
+biome.overworld.retro=Retro
+biome.overworld.hell=Hell
+biome.overworld.swampland.muddy=Muddy Swamp
+biome.overworld.outback.grassy=Grassy Outback
+biome.overworld.caatinga=Caatinga
+biome.overworld.caatinga.plains=Caatinga Plains
+biome.nether.nether=Nether
+biome.nether.volcanic_islands=Volcanic Islands
+biome.nether.sulfur_pools=Sulfur Pools
+biome.nether.crystal_forest=Crystal Forest
+biome.nether.ash_plains=Ash Plains
+biome.nether.boneyard=Boneyard
\ No newline at end of file
diff --git a/game/core/src/main/resources/lang/en_US/guidebook.lang b/game/core/src/main/resources/lang/en_US/guidebook.lang
index 8c2ce2cd7..dcbbbf22b 100644
--- a/game/core/src/main/resources/lang/en_US/guidebook.lang
+++ b/game/core/src/main/resources/lang/en_US/guidebook.lang
@@ -40,6 +40,8 @@ guidebook.section.mob.wolf.name=Wolf
 guidebook.section.mob.wolf.desc=Wolves are a passive mob that can be tamed using bones.\nThey can be found in colder biomes, such as taigas and boreal forests.
 guidebook.section.mob.firefly_cluster.name=Firefly
 guidebook.section.mob.firefly_cluster.desc=Fireflies appear as a shimmering cloud of light, and can be caught in jars to create lanterns.\nThey can be found in many biomes.
+guidebook.section.mob.butterfly.name=Butterfly
+guidebook.section.mob.butterfly.desc=Butterflies are a small insect that flies around from flower to flower, and can be caught in jars.
 guidebook.section.mob.zombie.name=Zombie
 guidebook.section.mob.zombie.desc=Zombies are a common enemy that appear at night and in darkness. They pack a strong punch, so be careful!
 guidebook.section.mob.creeper.name=Creeper
diff --git a/game/core/src/main/resources/lang/en_US/item.lang b/game/core/src/main/resources/lang/en_US/item.lang
index cb71745cc..f48e92eb3 100644
--- a/game/core/src/main/resources/lang/en_US/item.lang
+++ b/game/core/src/main/resources/lang/en_US/item.lang
@@ -422,4 +422,16 @@ item.wand.monster.name=Summoning Wand
 item.wand.monster.desc=A magical tool allowing the wielder to manifest living entities.
 
 item.paintbrush.name=Paintbrush
-item.paintbrush.desc=Can be loaded with dye and used to paint blocks.
\ No newline at end of file
+item.paintbrush.desc=Can be loaded with dye and used to paint blocks.
+
+item.jar.butterfly.blue.name=Blue Butterfly Jar
+item.jar.butterfly.blue.desc=A glass jar containing a blue butterfly.
+item.jar.butterfly.orange.name=Orange Butterfly Jar
+item.jar.butterfly.orange.desc=A glass jar containing a orange butterfly.
+item.jar.butterfly.pink.name=Pink Butterfly Jar
+item.jar.butterfly.pink.desc=A glass jar containing a pink butterfly.
+item.jar.butterfly.silver.name=Silver Butterfly Jar
+item.jar.butterfly.silver.desc=A glass jar containing a silver butterfly.
+
+item.statue.stone.name=Stone Statue
+item.statue.stone.desc=A decorative stone statue for you to hang your armor.
diff --git a/game/core/src/main/resources/lang/en_US/options.lang b/game/core/src/main/resources/lang/en_US/options.lang
index 29b517472..644440c4b 100644
--- a/game/core/src/main/resources/lang/en_US/options.lang
+++ b/game/core/src/main/resources/lang/en_US/options.lang
@@ -170,6 +170,8 @@ options.chatVisibility=Chat Visibility
 options.chatVisibility.show_all=Always Show
 options.chatVisibility.show_when_chatting=Only Show When Chatting
 options.chatVisibility.never_show=Never Show
+options.developerMode=Developer Mode
+options.forceOnscreenKeyboard=Force On Screen Keyboard
 options.enableHolidayTextures=Enable Holiday Textures
 
 options.tooltipStyle.default=Default
@@ -240,6 +242,7 @@ key.toggleOverlay=Toggle Overlays
 key.sortInventory=Sort Inventory
 key.openAchievements=Open Achievements Menu
 key.openStatistics=Open Statistics Menu
+key.showConsole=Show Console
 key.disabled=Disabled
 key.debug.textureAtlas=Show Texture Atlas
 key.debug.reload=Reload textures
diff --git a/game/core/src/main/resources/lang/en_US/stats.lang b/game/core/src/main/resources/lang/en_US/stats.lang
index 78ae41fe9..8543920a4 100644
--- a/game/core/src/main/resources/lang/en_US/stats.lang
+++ b/game/core/src/main/resources/lang/en_US/stats.lang
@@ -116,6 +116,6 @@ achievement.sleepNether.desc=Try to sleep in the Nether.
 achievement.lightSign=Glow in the Dark
 achievement.lightSign.desc=Apply Glowstone Dust to a sign.
 achievement.mostWanted=Most Wanted
-achievement.mostWanted.desc=Have more then 10 Zombie Pigmen attack you.
+achievement.mostWanted.desc=Have more than 10 Zombie Pigmen attack you.
 achievement.fastTravel=Dimensional Slingshot
-achievement.fastTravel.desc=Use the Nether to travel more then 8000 blocks in the Overworld.
\ No newline at end of file
+achievement.fastTravel.desc=Use the Nether to travel more than 8000 blocks in the Overworld.
\ No newline at end of file
